//
//  AppDelegate.swift
//  Demos
//
//

import PRESTOPlay
import CastlabsApple
#if !os(tvOS)
import CastlabsChromecast
import CastlabsDownloader
#endif
import CastlabsSubtitles
import CastlabsThumbnails
import CastlabsYoubora
import UIKit
import AVFoundation
import SwiftUI

@main
class AppDelegate: UIResponder, UIApplicationDelegate {
    var window: UIWindow?

    func application(
        _: UIApplication,
        didFinishLaunchingWithOptions _: [UIApplication.LaunchOptionsKey: Any]?)
        -> Bool
    {
        // Override point for customization after application launch.
        // swiftlint: disable line_length
        _ = PRESTOPlaySDK.shared.register(
            "LICENSE",
            [
                HLSPlugin(),
                SubtitlesPlugin(),
                ThumbnailsPlugin(),
                YouboraPlugin(YouboraSettings(accountCode: ""))
            ])
        // swiftlint: enable line_length
        try? AVAudioSession.sharedInstance().setCategory(.playback)

        window = UIWindow(frame: UIScreen.main.bounds)
        window?.rootViewController = UIHostingController(rootView: DemosView())
        window?.makeKeyAndVisible()
        return true
    }
}
