//
//  ViewController.swift
//  YouboraDemo
//
//

import PRESTOPlay
import CastlabsApple
import CastlabsYoubora
import AVFoundation
import UIKit
import YouboraLib

class ViewController: UIViewController {
    // create player instance
    var player = PRESTOPlaySDK.shared.player()
    var analytics: AnalyticsAPI?

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        // optional: ignore silent switch
        try? AVAudioSession.sharedInstance().setCategory(.playback)

        guard let contentURL =
            URL(
                string: "https://demo.cf.castlabs.com/media/prestohls/master.m3u8")
        else { return }

        let config = PlayerConfiguration(with: contentURL)
        player.load(config: config)

        player.onState = { previous, state in
            if let error = state.playerError {
                print("Error \(error)")
                return
            }
        }
        
        addYoubora()

        player.attach(to: view.layer)
        player.open(autoplay: true)
    }

    override func viewWillTransition(to size: CGSize,
                                     with coordinator: UIViewControllerTransitionCoordinator) {
        player.update(size: size)
    }

    func addYoubora() {
        analytics = PRESTOPlaySDK.shared.analytics(for: player, .youbora)
        let youboraMetadata = YouboraMetadata(
            live: false,
            assetId: "assetId"
        )
        youboraMetadata.options = YBOptions()
        youboraMetadata.options?.adCustomDimension1 = "test"
        youboraMetadata.options?.contentTitle = "test"
        analytics?.metadata = youboraMetadata
    }
}
